#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include <math.h>
#include <shellapi.h>
#include <dos.h>
#include <fcntl.h>
#include <mem.h>
#include <new.h>
#include <setjmp.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include "defines.h"
/*-----*/
char*progname=PROGNAME;
typedef uns char byte;
HMENU mainmenu; HWND mwn=0; HINSTANCE Instance=0,PrevInstance=0;
short CmdShow=0; byte Nn=0,fileopen=0;
char tit[256],title[256],file[256]={0},File[256]={0},KEYS[256];
OPENFILENAME ofn;
/*-----*/
int rundialogbox(HWND wn,HINSTANCE I,char*name,
  BOOL CALLBACK _export proc(HWND db,UINT M,WPARAM S,LPARAM L)) {
	 FARPROC dp=MakeProcInstance((FARPROC)proc,I);
	 int i=DialogBox(I,name,wn,dp); FreeProcInstance(dp); return i;}
/*-----*/
void diprintf(HWND db,int c,char*fmt,...){char C[256];
vsprintf(C,fmt,(&fmt)+1); SetDlgItemText(db,c,C);};
/*-----*/
int discanf(HWND db,int c,char*fmt,...){char C[256]; GetDlgItemText(db,c,C,256);
C[255]=0; return vsscanf(C,fmt,(&fmt)+1);}
/*-----*/
void diput(HWND db,int c,char*s){SetDlgItemText(db,c,s);};
/*-----*/
void diget(HWND db,int c,char*s){GetDlgItemText(db,c,s,256);}
/*-----*/
char askprompt[128],askbuffer[128];
BOOL CALLBACK _export newboxproc(HWND db,UINT M,WPARAM S,LPARAM L){
switch(M){default: return 0;
case WM_INITDIALOG: ValidateRect(mwn,0); diput(db,6,askprompt); diput(db,11,askbuffer); return 1;
case WM_KEYDOWN: case WM_KEYUP: case WM_SYSKEYDOWN: case WM_SYSKEYUP: {byte V=(byte)(S&0xff);
	 uns int rel=(short)((L>>31)&1); KEYS[V]=rel?0:0xff; if(KEYS[VK_ESCAPE]) goto _OUT; return 0;}
case WM_COMMAND: switch(S){
	 case IDOK: _OUT: diget(db,11,askbuffer);
	 case IDCANCEL:   EndDialog(db,1);}
	 return 1;}}
/*-----*/
int getstr(HWND wn,char*prompt,char*init) {ValidateRect(wn,0); strcpy(askprompt,prompt);
strcpy(askbuffer,init); rundialogbox(wn,Instance,"ASKDB",newboxproc); SetFocus(wn);
InvalidateRect(wn,0,0); return strcmp(prompt,askbuffer);}
/*-----*/
double ask(HWND wn,char*prompt,char*init) {double x;
while(getstr(wn,prompt,init),!sscanf(askbuffer,"%le",&x)); return x;}
/*-----*/
class xyz{public: double x,y,z; /* in Win32 needn't be a power of 2 bytes long */
xyz(){x=y=z=0;};
xyz(double X,double Y,double Z){x=X; y=Y; z=Z;}
xyz operator+(xyz a){return xyz(x+a.x,y+a.y,z+a.z);}
xyz operator-(xyz a){return xyz(x-a.x,y-a.y,z-a.z);}
xyz operator-(){return xyz(-x,-y,-z);}
xyz operator*(double m){return xyz(x*m,y*m,z*m);}
xyz operator/(double m){return xyz(x/m,y/m,z/m);}
void operator+=(xyz a){x+=a.x; y+=a.y; z+=a.z;}
void operator-=(xyz a){x-=a.x; y-=a.y; z-=a.z;}
void operator*=(double m){x*=m; y*=m; z*=m;}
void operator/=(double m){x/=m; y/=m; z/=m;}
double operator*(xyz a){return x*a.x+y*a.y+z*a.z;}
double rr(){return x*x+y*y+z*z;}
double r(){return sqrt(x*x+y*y+z*z);}};
/*-----*/
int GetFileName(HWND wn,char*file,char*t,char*f,int write) {int j;
strcpy(file,tit);
ofn.lStructSize=sizeof(OPENFILENAME); ofn.hwndOwner=wn;
ofn.lpstrFilter=f; ofn.lpstrCustomFilter=0; ofn.nFilterIndex=0;
ofn.lpstrFile=file; ofn.nMaxFile=128;
ofn.lpstrFileTitle=tit; ofn.nMaxFileTitle=256;
ofn.lpstrInitialDir=0; ofn.lpstrTitle=t;
ofn.Flags=write?OFN_OVERWRITEPROMPT:OFN_FILEMUSTEXIST;
j=(write?GetSaveFileName(&ofn):GetOpenFileName(&ofn))?1:0; return j;}
/*-----*/
int yesno(char*q){return MessageBox(0,q,"",MB_YESNO)==IDYES;}
/*-----*/
void SetTitle(HWND wn,char*S){SendMessage(wn,WM_SETTEXT,0,(long)S);}
/*-----*/
void GetTitle(HWND wn,char*S,long n){SendMessage(wn,WM_GETTEXT,n,(long)S);}
/*-----*//* scalar product */
double scprod(xyz a,xyz b){return a.x*b.x+a.y*b.y+a.z*b.z;}
/*-----*//* angle in degrees between planes ABC and ABD */
double dihedral(xyz A,xyz B,xyz C,xyz D) {
double r=(B-A).rr(),pc,pe; if(!r) return 99;
double p=scprod(B-A,B-C)/r,q=scprod(B-A,B-D)/r,theta,pi=4*atan(1.);
xyz P=A*p+B*(1-p),Q=A*q+B*(1-q),E=D+P-Q;
pc=(P-C).rr(); pe=(P-E).rr(); if(!pc?1:!pe) return 99.9;
r=(pc+pe-(C-E).rr())/2/sqrt(pc*pe);
theta=acos(-r*.9999); return theta*180/pi;}
/*-----*/
xyz*vert; int inv;
/*-----*//* extract vertex and texturemap and normal numbers and vertex coordinates
from an argument of an "f" line */
void findptn(char*C,long&p,long&t,long&n,xyz&v){long i=0,j,k,z=strlen(C); p=t=n=-99999;
k=sscanf(C  ,"%ld",&j); if(k) p=j; for(;i<z;i++) if(C[i]=='/') break;
k=p-1; if(k<0) k+=inv; v=(k>=inv?1:k<0)?xyz(0,0,0):vert[k]; /* vertex coords */
if(i++>=z) return;
k=sscanf(C+i,"%ld",&j); if(k) t=j; for(;i<z;i++) if(C[i]=='/') break; if(i++>=z) return;
k=sscanf(C+i,"%ld",&j); if(k) n=j;
if(Nn) for(i--;i<z;i++) C[i]=0; /* if(Nn), get rid of the normal number */}
/*-----*/
void pl(FILE*F,char*L,int*P,int n,int N){int i,j=strcmp(L+P[0],"f");
if(j) for(i=0;i<n;i++) putc(L[i]?L[i]:' ',F);
else {fprintf(F,"%s",L+P[0]); for(i=1;i<N;i++) fprintf(F," %s",L+P[i]);} putc('\n',F);}
/*-----*/
int readOBJ(HWND wn,char*file,char*File){
int i,j,k,l,m,n,M,N=-1,mm,nn,nv=0; long p[6],t[6],d[6]; xyz v[6]; double ww; char T[512];
char L[1024],R[1024],Eof=0; int P[1024],Q[1024],N3,N4; char ER[256]; GetTitle(wn,T,255);
if(!stricmp(file,File)) {MessageBox(0,file,"I can't copy a file to itself",OUCH); return 0;}
FILE*F=fopen(file,"rb");
if(!F) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
FILE*G=fopen(File,"w");
if(!G) {MessageBox(0,File,"I can't open this file",OUCH); fclose(F); return 0;}
Nn=yesno("shall I remove the normals (vn lines) to save more space?"); fileopen=1; N3=N4=0;
SetTitle(wn,"reading file to count the vertexes");
double limit=ask(wn,"max angle (deg) that two triangles can be out of plane?","5");
LOOP1: for(i=0;i<1023;i++) {j=L[i]=fgetc(F); Eof=Eof?1:feof(F); if(Eof?1:j==10?1:j==13) break;}
L[mm=i]=0; if(Eof) goto WHOA; /* read line into L */
for(i=0;i<mm;i++) if((int(L[i])&255)>32) break; /* skip leading spaces & tabs */
if((int(L[i])&255)=='v') if((int(L[i+1])&255)<=32) nv++; goto LOOP1; /* count vertex lines */
WHOA: fclose(F); Eof=0; F=fopen(file,"rb"); /* rewind the file */
if(!nv) {N3=N4=0; goto END;}
vert=new xyz[nv]; inv=0; /* to read the vertexes into */
SetTitle(wn,"working on file");
LOOP: for(i=0;i<1023;i++) {j=L[i]=fgetc(F); Eof=Eof?1:feof(F); if(Eof?1:j==10?1:j==13) break;}
L[mm=i]=0; if(Eof) goto END; /* read line into L */
for(i=0;i<mm;i++) if(L[i]<0?0:L[i]<=32) L[i]=0;
/* replace control chars (i.e. tabs etc) and spaces by ascii-nulls to separate the segments */
while(!mm?0:!L[mm-1]) mm--; /* get rid of trailing spaces */
if(!mm) goto LOOP; /* don't copy blank lines */
if(L[0]) {M=1; P[0]=0;} else M=0; for(i=1;i<mm;i++) if(L[i]) if(!L[i-1]) P[M++]=i;
/* make P[0:M-1] point to the segments of line L */
if(!strcmp(L+P[0],"v")) /* read a vertex */
  vert[inv++]=xyz(M<2?0:atof(L+P[1]),M<3?0:atof(L+P[2]),M<4?0:atof(L+P[3]));
if(Nn) if(!stricmp(L+P[0],"vn")) goto LOOP; /* lose the normals if he doesn't want them */
if(stricmp(L+P[0],"f")) goto NOTTRI; /* skip all this unless it's a face */
if(M==4) N3++; /* count the triangles */
if(N<0) {N=M; nn=mm; for(i=0;i<=mm;i++) R[i]=L[i]; for(i=0;i<M;i++) Q[i]=P[i]; goto LOOP;}
/* if the "previous face" buffer is empty, move this face into it */
if(N!=4) if(M==4) goto NOTCHG; /* if previous face isn't a triangle but this face is */
if(M!=4) goto NOTTRI; /* if this face isn't a triangle */
findptn(R+Q[1],p[0],t[0],d[0],v[0]); /* find the point & texturemap & normal numbers */
findptn(R+Q[2],p[1],t[1],d[1],v[1]); /* of these two faces */
findptn(R+Q[3],p[2],t[2],d[2],v[2]);
findptn(L+P[1],p[3],t[3],d[3],v[3]);
findptn(L+P[2],p[4],t[4],d[4],v[4]);
findptn(L+P[3],p[5],t[5],d[5],v[5]);
for(i=0;i<3;i++) for(j=3;j<6;j++) /* look for two shared corners */
  if(p[i]==p[j]) if(p[k=(i+1)%3,k]==p[l=3+(j+2)%3,l]) goto FOUND; goto NOTCHG;
FOUND: m=(i+2)%3; n=3+(j+1)%3; if(p[m]==p[n]) goto NOTCHG; /* reject if all 3 corners shared */
if(t[i]!=t[j] ?1: t[k]!=t[l]) goto NOTCHG; /* reject if texture map coords don't match */
ww=dihedral(v[i],v[k],v[m],v[n]); //fprintf(G,"# dihedral = %17.10f deg\n",ww);
if(ww>limit) goto NOTCHG; /* the 2 faces are too far from flat */
ww=dihedral(v[m],v[n],v[i],v[k]); //fprintf(G,"# dihedral = %17.10f deg\n",ww);
if(ww>limit) goto NOTCHG; /* the 2 faces are too far from flat */
fprintf(G,"f %s %s %s %s\n",R+Q[m+1],R+Q[i+1],L+P[n-3+1],R+Q[k+1]); /* output combined face */
N=-1; /* mark "previous line" buffer as empty */ N4++; goto LOOP;
NOTCHG: /* previous face isn't a triangle; print it & move this line into previous line */
if(N>=0) pl(G,R,Q,nn,N);
N=M; nn=mm; for(i=0;i<=mm;i++) R[i]=L[i]; for(i=0;i<M;i++) Q[i]=P[i]; goto LOOP;
NOTTRI: /* this line isn't a triangle or isn't a face: print previous line & this line */
if(N>=0) {pl(G,R,Q,nn,N); N=-1;} pl(G,L,P,mm,M); goto LOOP;
END: if(N>=0) pl(G,R,Q,nn,N); /* print previous line */
SetTitle(wn,T);
if(!N3) MessageBox(0,"this file may not be a mesh file",file,OUCH);
sprintf(ER,"%d triangles found, %d pairs of triangles joined",N3,N4); MessageBox(0,ER,"",OUCH);
fclose(F); fclose(G); fileopen=0; delete vert; return 1;}
/*-----*/
char*help="Copy an .obj mesh file, "
"joining any two triangular faces which are consecutive in list order "
"into one 4-sided face if:\n"
"they share two corners but not all three;\n"
"they have the same texture map coordinates (vt) at the two shared corners;\n"
"they are in the same material area (usemtl) and group;\n"
"they are no more than a specified amount away from being in the same plane.\n"
"Don't tell me to copy a file onto itself, as that may destroy the file.\n"
"Option to remove the normal (vn) information also to save more space.";
/*-----*/
LRESULT far pascal MainWinProc(HWND wn,UINT iMessage,WPARAM S,LPARAM L){PAINTSTRUCT PS;
WPARAM T; RECT R; long i,l; HDC dc;
static char*filterOBJ="OBJ files\000*.OBJ\000\000";
switch(iMessage) {default: DEF: return DefWindowProc(wn,iMessage,S,L);
case WM_ENTERIDLE: return 0;
case WM_CREATE: for(i=0;i<256;i++) KEYS[i]=0;
	 SetMenu(wn,mainmenu=LoadMenu(Instance,progname)); ShowWindow(wn,SW_SHOW/*MAXIMIZED*/);
	 goto DEF;
case WM_CLOSE: if(fileopen) {
	 MessageBeep(-1); SetTitle(wn,"Whoa there, I got a file open!!"); return 0;} goto DEF;
case WM_QUIT: goto DEF;
case WM_DESTROY: PostQuitMessage(0); return 0;
case WM_GETMINMAXINFO: {MINMAXINFO*p=(MINMAXINFO*)L;
	 p->ptMaxPosition.x=p->ptMaxPosition.y=-4; return 0;}
case WM_PAINT: GetClientRect(wn,&R); BeginPaint(wn,&PS); dc=GetDC(wn); GetClientRect(wn,&R);
	 DrawText(dc,help,strlen(help),&R,0x10); ReleaseDC(wn,dc); EndPaint(wn,&PS); goto DEF;
case WM_COMMAND: T=S; goto MENU;}
MENU: switch((unsigned short)T) {
case _READFILE_:
	 if(!GetFileName(wn,file,"file to read mesh from?",filterOBJ,0)) goto DEF;
	 if(!GetFileName(wn,File,"file to write mesh to?",filterOBJ,1)) goto DEF;
READING: l=strlen(file); if(stricmp(file+l-4,".obj")) goto RDBAD;
			l=strlen(File); if(stricmp(File+l-4,".obj")) goto RDBAD;
	 l=readOBJ(wn,file,File);
	 if(!l) MessageBox(wn,file,"I tried to read this file but it didn't work",OUCH); goto DEF;
	 RDBAD: MessageBox(wn,file,"bad suffix",OUCH); goto DEF;
	 RDOK: return 0;
case _EXIT_: SendMessage(wn,WM_CLOSE,0,0); return 0;}
return 0;}
/*-----*/
static void Register(char*name,WNDPROC proc) {WNDCLASS c;
c.style=CS_HREDRAW|CS_VREDRAW|CS_SAVEBITS; c.lpfnWndProc=proc; c.cbClsExtra=0;
c.cbWndExtra=2; c.hInstance=Instance; c.hIcon=LoadIcon(Instance,progname);
c.hCursor=LoadCursor(0,IDC_ARROW); c.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
c.lpszMenuName=0; c.lpszClassName=name; if(!RegisterClass(&c)) exit(0);}
/*-----*/
HWND newwindow(char*clas,char*name,long c=0){
HWND w=CreateWindow(clas,name,WS_OVERLAPPEDWINDOW|c,
	 CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,Instance,0);
	 if(w) {ShowWindow(w,SW_SHOW); UpdateWindow(w);} return w;}
/*-----*/
// Turn off warning: Parameter 'CmdLine' is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma argsused
// Turn off warning: 'MainWnd' is assigned a value that is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma option -w-aus
/*-----*/
int PASCAL WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int nCmdShow){
MSG msg; Instance=hInst; PrevInstance=hPrev; CmdShow=(short)nCmdShow;
if(!hPrev) Register(progname,MainWinProc);
mwn=newwindow(progname,progname,/*WS_HSCROLL|WS_VSCROLL|*/WS_MAXIMIZE); if(!mwn) exit(0);
while(GetMessage(&msg,0,0,0)) {TranslateMessage(&msg); DispatchMessage(&msg);}
return msg.wParam;}
